/**
  Definition of TURTLE GRAPHICS
  
  Fraga 12/09/2000
======================================================

    Modificaciones para la TAREA 08 por:
    Jorge J. Fernndez Arniz
    22/10/2000
    avion.cpp v.0.8.2

    Se crea un avin en pantalla a partir de 14 puntos que definen
    la figura bsica. En funcin del comando tecleado por el
    usuario, se aplica la transformacin 3D necesaria. Las posibles
    transformaciones, son:
    		Rotacion        R		sobre X, Y o Z
    		Escalamiento    S
    		
    La figura es dibujada usando una polilnea (drawPolyLine())
    Las rotaciones son con respecto al centro de masa del objeto, el cual
    hemos hecho que coincida con el origen del sistema de coordenadas.

    El cdigo de teclas, es el siguiente:
    ------------------------------------------------
    transformacin   +   -    descripcin
    ------------------------------------------------
                     U   I   ROTACIN SOBRE X
          R          J   K   ROTACIN SOBRE Y
                     M   ;   ROTACION SOBRE Z
          S          +   -   ESCALAMIENTO
    ------------------------------------------------
	
======================================================
Modificado para presentar al cubo unitario
rotanto sobre la diagonal (0,0,0) - (1,1,1)
Fraga 7/10/2000
Cubo v.0.0
**/

#ifndef CUBO_H
#define CUBO_H

#include <qwidget.h>
#include <iostream.h>
#include <qtimer.h>

class Cubo : public QWidget
{
	Q_OBJECT
public:
	
	Cubo( QWidget *parent=0, const char *name=0 );
	// JFA: Prueba el algortmo Midpoint...
	void LineMidpoint (int x1, int y1, int y1, int y2, QColor color);
	void LineMidpoint (QPoint p1, QPoint p2, QColor color) {
			LineMidpoint(p1.rx(), p1.ry(), p2.rx(), p2.ry(), color); };
	void LineMidpoint (QPoint p, QColor color) {
			LineMidpoint(int (xact), int (yact), p.rx(), p.ry(), color); };

	// JFA: Intercambia P1 con P2 y dos enteros
	void SwapPoints(int &x1, int &y1, int &x2, int &y2);
	void IntSwap(int &e1, int &e2);

	// JFA: Casos especiales: Diagonal, vertical y horizontal
	void DrawDiagonal(int x1, int y1, int x2, int y2, QColor color);
	void DrawVertical(int x1, int y1, int x2, int y2, QColor color);
	void DrawHorizontal(int x1, int y1, int x2, int y2, QColor color);

	// JFA: Primitivas para tortuga
	void Forward(double dist);
	void Back(double dist);
	
	// JFA: se implementan aqu mismo:
	void Right(double grados) {
		ang -= grados;
		if (ang < 0.0)
				ang += 360.0;
		};
	void Left(double grados)  {
		ang += grados;
		if (ang > 360.0)
				ang -= 360.0;
		};

	// Para la tarea #8....
	void drawCubo3D();
	void cambiaEscala3D(double factor); 			// escala...
	void cambiaRota3D(float angulo, char eje);	  // rotacin
	void aplicaT3D(int indice);
	void puntos(void);
	
	void PenUp ( void ) { penst=0;}
	void PenDown ( void ) { penst=1;}

	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *width, int *height ) { *width = w; *height = h; }
	QSizePolicy sizePolicy() const;
	
public slots:
	void timerDone( void );
	void initscreen( void ) { 
		// timer->start(1000, TRUE );
		timer->start(400 );
	}
	void stop( void ) {
		timer->stop( );
 	} 

 void setStyle(const int &cual) {
 		cout << "cambia << cual << \n";
 }

 signals:
 void changePos( ); // called when mouse is moved
 void changeSize( ); // called when windows is resized
 
 protected:
 void paintEvent( QPaintEvent * );
 void mouseMoveEvent( QMouseEvent * );
 void resizeEvent( QResizeEvent * );
 
private:
	void puntosAenteros( void );
	QTimer *timer;

  // JFA: en punto flotante...
  typedef struct {
 		double fx, fy, fz;
  } fPunto3D;

  // JFA: como enteros listo para graficar....
  typedef struct {
 		int x, y, z;
  } iPunto3D;
	// El numero de puntos
	int Npuntos;

  double Matrix3D[4][4];
	fPunto3D fpuntos3D[10];		
	iPunto3D ipuntos3D[10];
		
	// JFA: factores para las transformaciones:
	double factorEscala;	// JFA: escala obviamente
	int factorRota;				//      ngulo actual
	int factorTrasl;			//      traslacion
	double factorSesgo;		//      sesgo

  int w, h;        // canvas width and height
  int xini, yini;  // Initial coordinates (the origin)
  int xact, yact;  // Actual turtle position
  double xact_d, yact_d;
  double ang;		 // Turtle angle in degrees
  int penst;       // Pen state: 1 = dowm, 0 = up
  QColor pen_color;   // Actual color of the pen
  int xmouse, ymouse;  // Mouse pointer coordinates
	//int ancho;
};


#endif // CUBO_H
